package decatur.de.rigorous.numutil;

public class CenteredInterval {
  public double center, radius;

  public CenteredInterval (CenteredInterval src) {
    set (src);
  }
 
  public CenteredInterval (double center, double radius) {
    set (center, radius);
  }

  public CenteredInterval (double c) {
    set (c);
  }

  public CenteredInterval () {
    set (0.0);
  }

  public String toString () {
    return String.valueOf(center)+"+-"+String.valueOf(radius);
  }
    
  public void set (CenteredInterval src) {
    center = src.center;
    radius = src.radius;
  }

  public void set (double c) {
      center = c; radius = 0.0;
  }

    public void set (double center, double radius) {
	if ( radius<0.0 )
	    throw new ArithmeticException ("Negative radius.");
	this.center = center; this.radius = radius;
    }

    public Interval interval () {
	return new Interval (IEEE.pred(center-radius),
			     IEEE.succ(center+radius));
    }
}

