package decatur.de.rigorous.numutil;

public final class IEEE {

  static double Eta     = Double.longBitsToDouble(0x1L);
  static double Epsilon = Double.longBitsToDouble(0x3CA0000000000000L);
  static final int InvalidBits = 0; /* # of invalid digits in calculation of std. func. */
  static double StdFuncOnePlusEps =  1.0 + (1 << (InvalidBits + 1)) * Epsilon;
  static double StdFuncOneMinusEps = 1.0 - (1 << (InvalidBits + 1)) * Epsilon;
  static double OnePlusEps =  1.0 + Epsilon;
  static double OneMinusEps = 1.0 - Epsilon;
  
  public static double succ (double a) {
    return ((a < 0.0) ? OneMinusEps : OnePlusEps) * (a) + Eta;
  }

  public static double pred (double a) {
    return ((a < 0.0) ? OnePlusEps : OneMinusEps) * (a) - Eta;
  }

  public static double down (double a) {
    return ((a < 0.0) ? StdFuncOnePlusEps : StdFuncOneMinusEps) * (a) - Eta;
  }

  public static double up (double a) {
    return ((a < 0.0) ? StdFuncOneMinusEps : StdFuncOnePlusEps) * (a) + Eta;
  }
}

