package decatur.de.rigorous.numutil;

public final class blas {
  public static void copy (double []dest, double []src) {
    System.arraycopy (src, 0, dest, 0, src.length);
  }

  public static void copy (double [][]dest, double [][]src) {
    for (int i=0; i<src.length; i++)
      System.arraycopy (src[i], 0, dest[i], 0, src[i].length);
  }

  public static void cast (Interval []dest, double []src) {
    for (int i=0; i<dest.length; i++)
      dest[i].set(src[i]);
  }

  public static void flush (double []a) {
    for (int i=0; i<a.length; i++) a[i]=0;
  }


  public static double l1_norm (double []a) {
    double norm=0;
    int dim = a.length;
    for (int i=0; i<dim; i++) norm = IEEE.succ(norm+Math.abs(a[i]));
    return norm;
  }

  public static double lsup_norm (double []a) {
    double norm=Math.abs(a[0]);
    int dim = a.length;
    for (int i=1; i<dim; i++) 
      if (Math.abs(a[i])>norm) norm = Math.abs(a[i]);
    return norm;
  }

  public static void add (double []c, double []a, double []b) {
    int dim = c.length;
    for (int i=0; i<dim; i++) c[i]=IEEE.succ(a[i]+b[i]);
  }

  public static void mul (Interval [][]C, double [][]A, double [][]B) {
    int dim = C.length;
    for (int i=0; i<dim; i++)
      for (int j=0; j<dim; j++) {
	Interval sum = C[i][j];
	sum.set (0);
	for (int k=0; k<dim; k++)
	  sum.add (Interval.mul(A[i][k], B[k][j]));
     } 
  }

  public static void mul (double []c, double [][]A, double []b) {
    int dim = c.length;
    for (int i=0; i<dim; i++) {
      double sum = 0;
      for (int j=0; j<dim; j++)
	sum = IEEE.succ(sum+IEEE.succ(A[i][j]*b[j]));
      c[i]=sum;
    }
 }

  public static void abs (double [][]A, Interval [][]B) {
    int dim = A.length;
    for (int i=0; i<dim; i++)
      for (int j=0; j<dim; j++) 
	A[i][j] = Interval.abs(B[i][j]);
  }

  public static void row_sum (double []a, double [][]B) {
/* Compute the row sum of a matrix. Correct rounding is used.  */
    int dim = a.length;
    for (int i=0; i<dim; i++) {
      double sum = 0.0;
      for (int j=0; j<dim; j++)
	sum = IEEE.succ(sum+Math.abs(B[i][j]));
      a[i] = sum;
    }
  }

  public static void Interval2center (double []c, double []r,
				      Interval []a) {
      int dim = a.length;
      CenteredInterval ci;
      for (int i=0; i<dim; i++) {
	  ci = a[i].centered();
	  c[i] = ci.center; r[i] = ci.radius;
      }
  }

  public static void Interval2center (double [][]C, double [][]R,
				      Interval [][]A) {
      int dim = A.length;
      for (int i=0; i<dim; i++)
	  Interval2center (C[i], R[i], A[i]);
  }

  public static void center2Interval (Interval []a, double []c, double []r) {
      int dim = a.length;
      for (int i=0; i<dim; i++)
	  a[i].setCentered (c[i], r[i]);
  }
    
  public static void print (double []a) {
    System.out.println(a.toString());
    for (int i=0; i<a.length; i++)
      System.out.println(a[i]);
  }

  public static void print (double [][]A) {
    System.out.println(A.toString());
    for (int i=0; i<A.length; i++)
      for (int j=0; j<A[i].length; j++)
	System.out.println(A[i][j]);
  }
}

