package decatur.de.rigorous.plot;
import java.awt.Point;

class SbMatrix {
    float sx, sy, tx, ty;
    
    SbMatrix () {
	set (1.0f, 1.0f, 0.0f, 0.0f);
    }
    
    SbMatrix (float sx, float sy, float tx, float ty) {
	set (sx, sy, tx, ty);
    }

    SbMatrix (SbMatrix m) {
	set (m);
    }

    public void set (float sx, float sy, float tx, float ty) {
	this.sx = sx;
	this.sy = sy;
	this.tx = tx;
	this.ty = ty;
    }

    public void set (SbMatrix m) {
	sx = m.sx;
	sy = m.sy;
	tx = m.tx;
	ty = m.ty;
    }
    
    public void scale (float sx, float sy) {
	this.sx *= sx;
	this.sy *= sy;
	//	System.out.println (""+this);
    }
    
    public void translate (float dx, float dy) {
	tx += sx*dx;
	ty += sy*dy;
	//	System.out.println (""+this);
    }
    
    void transform (Point p, float x, float y) {
	p.x = (int) Math.round(sx*x+tx);
	p.y = (int) Math.round(sy*y+ty);
    }

    void transform (SbVec2f p, float x, float y) {
	p.x = sx*x+tx;
	p.y = sy*y+ty;
    }
    
    void dtransform (Point p, float dx, float dy) {
	p.x = (int) Math.round(sx*dx);
	p.y = (int) Math.round(sy*dy);
    }

    void dtransform (SbVec2f p, float dx, float dy) {
	p.x = sx*dx;
	p.y = sy*dy;
    }
    

    void itransform (SbVec2f p, float x, float y) {
	p.x = (x-tx)/sx;
	p.y = (y-ty)/sy;
    }

    void idtransform (SbVec2f p, float x, float y) {
	p.x = x/sx;
	p.y = y/sy;
    }

    public String toString () {
	return new String ("Matrix: "+sx+" "+sy+" "+tx+" "+ty);
    }
}
