package decatur.de.rigorous.plot;

import decatur.de.rigorous.numutil.SplineInterpolant;

public class SimplePlotFrame extends NiceFrame {
    private SoTransform transform;
    private SoAxisCanvas plot;

    public SimplePlotFrame (SplineInterpolant spline) {
	init (spline);
    }

    public SimplePlotFrame (double x[], double y[]) {
	SplineInterpolant spline = new SplineInterpolant (x, y);
	init (spline);
    }

    private void init (SplineInterpolant spline) {
	int n = (spline.x.length-1)*10+1;
	double xi[] = new double[n];
	double yi[] = new double[n];

	xi[n-1] = spline.x[spline.x.length-1];
	for (int i=0; i<spline.x.length-1; i++) {
	    double h = (spline.x[i+1]-spline.x[i])/10;
	    for (int k=0; k<10; k++)
		xi[i*10+k] = spline.x[i]+k*h;
	}

	spline.validate ();
	spline.interpolate (xi, yi);

	plot = new SoAxisCanvas (300, 300);
	
	transform = new SoTransform ();;
	plot.addNode (transform);

	SoLineSet graph = new SoLineSet (n);
	graph.set (xi, yi);

	plot.addNode (graph);
	plot.setXRange (SoAxisCanvas.AUTOMATIC);
	plot.setYRange (SoAxisCanvas.AUTOMATIC);
	plot.touch();

	add ("Center", plot);
	validate ();
	pack ();
    }

    public void setScale (float sx, float sy) {
	transform.setScale (sx, sy);
	plot.touch();
    }

}
