package decatur.de.rigorous.plot2d;

public class Double10 {
  long m;
  int e;

  public Double10 () {
    super ();
  }

  void set (double x, int k) {
    if (x==0.0) {
      m=e=0; return;
    }
    boolean neg = (x<0.0);
    x = Math.abs(x);
    e = (int) Math.floor(Math.log(x)/Math.log(10.0))-k;
    m = (long) (x*Math.pow(10, -e));
    //    System.out.println("x: "+x+" e: "+e+" m: "+m);
    if (neg) m *= -1l;
  }

  public double nicest (double a, double b) {
    if ( a<=0.0 && b>=0.0 ) return 0.0;
    int sign = 1;
    if ( b<=0.0 ) {
      sign = -1;
      double t=-a; a=-b; b=t;
    }
    //    System.out.println("nicest:");
    set((a+b)/2, 12);
    long last;
    double d = 0.0;
    do {
      last = m;
      m /= 10; e++;
      d=value();
      if ( d<a || d>b ) break;
      //      System.out.println("d: "+d+" a: "+a+" b: "+b+" sign: "+sign);
    } while (true);
    m = m+1;
    d = value();
    if ( d>b ) {
      m = last; e--;
    }
    m *= sign;
    return value();
  }

  public static String format (double d) {
    Double10 x = new Double10();
    double eps = 1e-14;
    d *= (1.0+eps);
    x.set(d,12);
    return x.toString();
  }

  public static String format (double a, double b) {
    Double10 x = new Double10();
    x.nicest (a, b);
    return x.toString();
  }

  public String toString () {
    Double d = Double.valueOf(""+m+"e"+e);
    String s = d.toString();
    if ( s.endsWith(".0") )
      return s.substring(0, s.length()-2);
    else return s;
  }

  double value() {
    return m*Math.pow(10,e);
  }
}
