/*
 * Test.java
 *
 * Created on January 8, 2004, 8:08 PM
 */

package decatur.de.rigorous.plot;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

import decatur.de.rigorous.plot.SoAxisCanvas;
import decatur.de.rigorous.plot.SoPolygon;


/**
 *
 * @author  Wolfgang Kuehn
 */
    
class Test extends Component implements ActionListener {

    public Dimension getPreferredSize() {
        return new Dimension(300, 300);
    }

    public void paint(Graphics g) {
        // Note: For most efficient repainting, we should check the
        // clip rectangle in the Graphics object to determine the
        // damaged region and only paint that;  we don't do that here
        // for simplicity in this example
        //
        Rectangle r = getBounds();

        g.setColor(Color.black);
        g.fillRect(0, 0, r.width, r.height);

        g.setColor(Color.yellow);
        g.drawLine(0, 0, r.width, r.height);

        g.setColor(Color.white);
        g.drawLine(0, r.height, r.width, 0);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws java.io.IOException {
        Frame f = new Frame();
        f.setLayout(new FlowLayout());
        
        Test t = new Test();
        f.add(t);
        
        Button b = new Button("Quit");
        b.setActionCommand("quit");
        b.addActionListener(t);
        f.add(b);
        
        SoPolygon poly = new SoPolygon (4);
	poly.setColor (Color.magenta);
	poly.setFilled (true);
	poly.setOutlined (true);
	poly.x[0] = poly.x[1] = 1;
	poly.y[0] = 2;
	poly.y[1] = 4;
	poly.x[2] = poly.x[3] = 5; 
	poly.y[2] = 6;
	poly.y[3] = 3;
        
        SoAxisCanvas canvas = new SoAxisCanvas (400, 400);
        canvas.addNode (poly);
        f.add(canvas);
        
        canvas.setXRange (-10, 10);
	canvas.setYRange (0, 10);
	canvas.touch ();
        
        if (true) {
            BufferedImage bi = new BufferedImage(400, 400, BufferedImage.TYPE_INT_RGB);
            canvas.paint1(bi.getGraphics());
            java.io.File file = new java.io.File("c:/tmp/canvas.png");
            javax.imageio.ImageIO.write(bi, "png", file);
        } else {
            f.pack();
            f.setVisible(true);
        }
    }
    
    public void actionPerformed(ActionEvent evt) {
        String cmd = evt.getActionCommand();

        if (cmd.equals("quit")) { 
           // Implement Copy operation
           System.exit(1);
        }
    }

}
